import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import java.io.File;

public class Main {

    public static void main(String[] args) throws JAXBException {

        Zoo zoo = makeZoo();

        File outFile = new File("cats.xml");

        // 1
        Marshaller marshaller = getMarshaller(Zoo.class, Cat.class);
        marshaller.marshal(zoo, outFile);

        System.out.println("сериализация завершена");
    }

    /**
     * Функция для создания объекта Zoo
     *
     * @return объект zoo
     */
    private static Zoo makeZoo() {
        Zoo zoo = new Zoo();
        zoo.addCat(new Cat("Boris", 10));
        zoo.addCat(new Cat("Tom", 5));
        return zoo;
    }

    /**
     * Функция для создания Marshaller.
     *
     * @param classes Список классов, которые участвуют в сериализации
     * @return Marshaller
     */
    private static Marshaller getMarshaller(Class... classes) throws JAXBException {
        JAXBContext context = JAXBContext.newInstance(classes);
        Marshaller marshaller = context.createMarshaller();
        marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
        return marshaller;
    }
}
